# Contributing to Healpix.jl

If you are reading this, it is likely you want to contribute to this project. Thank you! Here are a few ways you can help improving Healpix.jl.

## Improve the documentation

One of the most important parts of a package, if not **the** most important, is the documentation. If you think that the documentation is not adequate, why don't you help us in improving it? It does not require to be an expert Julia programmer, and it is probably the most straightforward way to contribute to this project. Here are a few possible ways to improve the documentation:

-   Fix typos, correct grammar errors;
-   Explain some concepts better;
-   Provide more examples.

The documentation has been written using [Documenter.jl](https://github.com/JuliaDocs/Documenter.jl), and the [Markdown](https://en.wikipedia.org/wiki/Markdown) files are available in the [`docs/src` directory](https://github.com/ziotom78/Healpix.jl/tree/master/docs/src).

If your just need to fix a typo or change a few sentences, you can even use GitHub's online editor: this is by far the easiest path. See [GitHub's help page](https://help.github.com/articles/editing-files-in-another-user-s-repository/) for more information. Otherwise, do all your changes in a local copy and [create a new pull request](https://github.com/ziotom78/Healpix.jl/pulls).

## File a bug report

If you have spotted a bug, you can [create a new issue](https://github.com/ziotom78/Healpix.jl/issues/new).

## Contribute code

Finally, you can also help us developing the package itself! You need some experience with Git, GitHub, and the development of Julia packages.

To learn the basics of Git and GitHub, you can study a basic [`hello-world`](https://guides.github.com/activities/hello-world/) example. Refer to 
the [Git Pro Book (2nd edition)](https://git-scm.com/book/en/v2) for more information about Git. To learn more about Julia packages, there is the  [official documentation](https://docs.julialang.org/en/v1/stdlib/Pkg/#Developing-packages-1).

Once you are confident with these tools, here are the steps to propose changes to the code:
1. Either find an [open issue](https://github.com/ziotom78/Healpix.jl/issues) or open a
    new issue for the problem you want to solve;
2. It is a good idea to discuss the issue with the other developers before starting writing too much code.
3. Once the team agrees about the changes you have proposed, you can start coding them locally on your computer. **Be sure to add tests and documentation**!
4. Submit a new [pull request(https://github.com/ziotom78/Healpix.jl/pulls).
5. If there are comments to your pull request, update your code accordingly until the pull request is merged.

Happy coding!
